<template>
  <form @submit.prevent="submitForm">
    <slot></slot>
  </form>
</template>

<script>
import Form, { formComputed, formMethods, formProviders } from './libs/form'

export default {
  name: 'VumikForm',
  provide () {
    return {
      ...formProviders(this)
    }
  },
  model: {
    prop: 'vumikValue',
    event: 'input'
  },
  props: {
    name: {
      type: [String, Boolean],
      default: false
    },
    vumikValue: {
      type: Object,
      default: () => ({})
    }
  },
  data () {
    return {
      ...new Form(this).data()
    }
  },
  computed: {
    ...formComputed()
  },
  watch: {
    vumikValue: {
      handler (values) {
        if (values && typeof values === 'object') {
          this.setValues(values)
        }
      },
      deep: true
    }
  },
  created () {
    this.applyInitialValues()
  },
  methods: {
    ...formMethods(),
    submitForm () {
      this.$emit('submit')
    }
  }
}
</script>
